# FLUX.1 [dev] with Controlnets and Loras API

> FLUX.1 [dev] text-to-image e LoRAs, ControlNets, IP-Adapters, EasyControl thaj referencaki ilustracijaki gidijasa

Kerel ilustracije andar jekh `prompt`, e but kondicioniripnaske metodenca: `loras`, `control_loras`, `controlnets`, `controlnet_unions`, `ip_adapters` thaj `easycontrols`, plus `fill_image` vaś maskime than. Lel vi `reference_image_url`, negativna promptura, thaj euler vaj dpmpp_2m scheduler. Dži 10 ilustracije jekh call-este, png vaj jpeg.

- Model id: `flux-general`
- Made by: Black Forest Labs
- Category: Text to Image
- Output: image
- Estimated price per run: $0.30 / image (cheapest run $0.30 (300 API credits))
- Run: `POST https://api.doitong.ru/v1/run/flux-general`
- Quote: `POST https://api.doitong.ru/v1/quote/flux-general`
- Docs page: https://doitong.com/rom/developers/models/flux-general

## Pricing

Price: **$0.30 / image**. Estimated from the typical cost of one run, per output (`num_images`). The quote is exactly what the run charges.

The full example input below costs $0.30 = 300 API credits (1 image × 300 API credits).

Prices are the upstream price in USD, paid from the API balance in API credits (1000 API credits = 1 USD). `POST https://api.doitong.ru/v1/quote/flux-general` with the same JSON body returns the exact price for that input; the quote is exactly what a run charges. Invalid input is never charged and failed or canceled requests are refunded automatically.

## Input parameters

Send either the canonical name or the native field name (not both). Canonical names are the same across models.

| Parameter | Canonical name | Type | Required | Default | Allowed values / range | Description |
|---|---|---|---|---|---|---|
| `prompt` |  | string | yes |  |  | Prompto savo dromarel kipoqo generiripe. |
| `image_size` |  | object {width, height} \| enum (string) | no |  | `square_hd`, `square`, `portrait_4_3`, `portrait_16_9`, `landscape_4_3`, `landscape_16_9` | Dimenzije kerde kiposke. |
| `num_inference_steps` |  | integer | no | `28` | 1 – 50 | Gin inference steps pala te kerel. |
| `seed` |  | integer \| null | no |  |  | Semeno vaš pale-keriteľne kipura: jekh prompto thaj semeno den jekh kipo kana o modeloski verzia na paruvľa. |
| `loras` |  | array of object {path, scale} | no | `[]` |  | LoRA-ja savenge jekhipen kerel o generime kipo, bi limitosko pe lengero gindo. |
| `loras[].path` |  | string | yes |  |  | Lokacia e LoRA vazipnaski, specifikime sar URL vaj drom. |
| `loras[].scale` |  | object \| number | no | `1` |  | Skaliripe savo aplikil pe e LoRA pharimatengo anglal te aven kethane thode ando bazutno modelo. De jekh dikcionaro ande forma {"layer_name":layer_scale} te thos averčhane skale vaš e slojura; e na dikhle slojura len 1.0. |
| `control_loras` |  | array of object {path, scale, control_image_url, preprocess} | no | `[]` |  | Control-image LoRA-ja merge kerde ande jekhipasko konfiguracija vaš keripe finalone kipesko; o delipeko gindo naj limitime. |
| `control_loras[].path` |  | string | yes |  |  | Lokacia e LoRA vazipnaski, specifikime sar URL vaj drom. |
| `control_loras[].scale` |  | object \| number | no | `1` |  | Skaliripe savo aplikil pe e LoRA pharimatengo anglal te aven kethane thode ando bazutno modelo. De jekh dikcionaro ande forma {"layer_name":layer_scale} te thos averčhane skale vaš e slojura; e na dikhle slojura len 1.0. |
| `control_loras[].control_image_url` |  | string (image URL) | yes |  |  | Kipesko URL savo del o control kipo. |
| `control_loras[].preprocess` |  | enum (string) | no | `None` | `canny`, `depth`, `None` | Preprocessing metodo aplikime pa dino kipo. |
| `controlnets` |  | array of object {path, config_url, variant, control_image_url, mask_image_url, mask_threshold, conditioning_scale, start_percentage, end_percentage} | no | `[]` |  | ControlNet konfiguracija vaš kipesko keripe, akana limitime pe jekh ControlNet. |
| `controlnets[].path` |  | string | yes |  |  | Than e ControlNet vektorengo, specifikime sar URL vaj drom. |
| `controlnets[].config_url` |  | string \| null | no |  |  | Optional URL savo sikavel e ControlNet-esko config.json fajlo. |
| `controlnets[].variant` |  | string \| null | no |  |  | Optionalo variant vaš use e Hugging Face repository key-sa. |
| `controlnets[].control_image_url` |  | string (image URL) | yes |  |  | Kipesko URL savo del o control kipo. |
| `controlnets[].mask_image_url` |  | string (image URL) | no |  |  | Maskesko URL pherdo e control kipesa. |
| `controlnets[].mask_threshold` |  | number | no | `0.5` | 0.01 – 0.99 | Mask threshold value. |
| `controlnets[].conditioning_scale` |  | number | no | `1` | 0 – 2 | Skaliripe savo aplikil pe e ControlNet pharimatengo anglal te aven kethane thode ando bazutno modelo. |
| `controlnets[].start_percentage` |  | number | no | `0` | 0 – 1 | Procento total timesteps-engo kana ControlNet startarel te influencinel kipesko keripe. |
| `controlnets[].end_percentage` |  | number | no | `1` | 0 – 1 | Procento total timesteps-engo kana ControlNet stoparel te influencinel kipesko keripe. |
| `controlnet_unions` |  | array of object {path, config_url, variant, controls} | no | `[]` |  | ControlNet union konfiguracija vaš kipesko keripe, thodli tale akanačuno jekh-ControlNet restriction. |
| `controlnet_unions[].path` |  | string | yes |  |  | Than e ControlNet vektorengo, specifikime sar URL vaj drom. |
| `controlnet_unions[].config_url` |  | string \| null | no |  |  | Optional URL savo sikavel e ControlNet-esko config.json fajlo. |
| `controlnet_unions[].variant` |  | string \| null | no |  |  | Optionalo variant vaš use e Hugging Face repository key-sa. |
| `controlnet_unions[].controls` |  | array of object {control_image_url, mask_image_url, control_mode, conditioning_scale, mask_threshold, start_percentage, end_percentage} | yes |  |  | Control kipa thaj lengere mode-ja save den pes e ControlNet-te. |
| `controlnet_unions[].controls[].control_image_url` |  | string (image URL) | yes |  |  | Kipesko URL savo del o control kipo. |
| `controlnet_unions[].controls[].mask_image_url` |  | string (image URL) | no |  |  | Maskesko URL pherdo e control kipesa. |
| `controlnet_unions[].controls[].control_mode` |  | enum (string) | yes |  | `canny`, `tile`, `depth`, `blur`, `pose`, `gray`, `low-quality` | Control modo savo lel Flux Controlnet Union. Options: canny dromarel e keripe e edge-enca; tile dromarel les tile-enca; depth dromarel les grayscale depth map-esa; blur kerel blur e kipes; pose dromarel e keripe e kipeska poseska; gray kerel o kipo grayscale; low-quality kerel low-quality verzija kipeski. |
| `controlnet_unions[].controls[].conditioning_scale` |  | number | no | `1` | 0 – 2 | Skaliripe savo aplikil pe e ControlNet pharimatengo anglal te aven kethane thode ando bazutno modelo. |
| `controlnet_unions[].controls[].mask_threshold` |  | number | no | `0.5` | 0.01 – 0.99 | Mask threshold value. |
| `controlnet_unions[].controls[].start_percentage` |  | number | no | `0` | 0 – 1 | Procento total timesteps-engo kana ControlNet startarel te influencinel kipesko keripe. |
| `controlnet_unions[].controls[].end_percentage` |  | number | no | `1` | 0 – 1 | Procento total timesteps-engo kana ControlNet stoparel te influencinel kipesko keripe. |
| `ip_adapters` |  | array of object {path, subfolder, weight_name, image_encoder_path, image_encoder_subfolder, image_encoder_weight_name, image_url, mask_image_url, mask_threshold, scale} | no | `[]` |  | IP-Adapter aplikime andar kipesko keripe. |
| `ip_adapters[].path` |  | string | yes |  |  | IP-Adapter-esko than pe Hugging Face. |
| `ip_adapters[].subfolder` |  | string \| null | no |  |  | Subfolder savo lel e ip_adapter vektora. |
| `ip_adapters[].weight_name` |  | string \| null | no |  |  | Safetensors fajlosko nav vaš IP-Adapter vektora. |
| `ip_adapters[].image_encoder_path` |  | string | yes |  |  | IP-Adapter kipesko encoder-esko than, sar 'openai/clip-vit-large-patch14'. |
| `ip_adapters[].image_encoder_subfolder` |  | string \| null | no |  |  | Subfolder savo lel e kipeskere encoder-eske vektora. |
| `ip_adapters[].image_encoder_weight_name` |  | string \| null | no |  |  | Kipesko encoder-esko nav. |
| `ip_adapters[].image_url` |  | string (image URL) | yes |  |  | Conditioning kipesko URL savo del pes e IP-Adapter-te. |
| `ip_adapters[].mask_image_url` |  | string (image URL) \| null | no |  |  | Maskesko URL pherdo e control kipesa. |
| `ip_adapters[].mask_threshold` |  | number | no | `0.5` | 0.01 – 0.99 | Mask threshold value. |
| `ip_adapters[].scale` |  | number | yes |  |  | IP-Adapter skaliripasko faktor. |
| `easycontrols` |  | array of object {control_method_url, scale, image_url, image_control_type} | no | `[]` |  | EasyControl inputo save aplikirena andar kipesko keripe. |
| `easycontrols[].control_method_url` |  | string | yes |  |  | Control metodo safetensor weight-esko URL vaj podderdo identifier: `canny`, `depth`, `hedsketch`, `inpainting`, `pose`, `seg`, `subject`, `ghibli`. |
| `easycontrols[].scale` |  | number | no | `1` | 0 – 2 | Control metodo skaliripasko faktor. |
| `easycontrols[].image_url` |  | string (image URL) | yes |  |  | Kipesko URL savo del o control inputo. |
| `easycontrols[].image_control_type` |  | enum (string) | yes |  | `subject`, `spatial` | Kipesko control modo; lel vaj `spatial` vaj `subject`. |
| `fill_image` |  | object {fill_image_url} \| null | no |  |  | Inputo kipo savo dromarel e keripe thaj šaj del kontento vaš masked region-ja. |
| `fill_image.fill_image_url` |  | string (image URL) \| array of image URL | no | `[]` |  | Kipeskere URL-ja vaš pheripe e redux promptinga. |
| `guidance_scale` |  | number | no | `3.5` | 0 – 20 | Zor e promptoske pačajipaski vaś izbor e kiposko, sikavdi sar CFG (Classifier Free Guidance). |
| `real_cfg_scale` |  | number | no | `3.5` | 0 – 5 | Zor e promptoske pačajipaski vaś izbor e kiposko, sikavdi sar CFG (Classifier Free Guidance). |
| `use_real_cfg` |  | boolean | no | `false` |  | Classical CFG switch, avtomatikane aktivime e XLabs IP-Adapter v1-sa. E guidance comportimento si jekh sar ko modelo SD1.5 thaj SDXL. |
| `use_cfg_zero` |  | boolean | no | `false` |  | Aktivirinel CFG-zero initialization sampling, opisime pe https://arxiv.org/abs/2503.18886. |
| `num_images` | `num_outputs` | integer | no | `1` | 1 – 10 | Thov save kipa te keren; kadava choice si phandlo pe 1 kana o rezultato stream-kerdo. |
| `enable_safety_checker` |  | boolean | no | `true` |  | Safety-checking savo thovel kale kipo thaneste sako unsafe kipo. True aktivarel checking; false deaktivuil la numa autorizirime kontonge, kana mangipena bi autorizacia si checking zorutno. |
| `reference_image_url` |  | string (image URL) | no |  |  | Kipesko URL savo lel pes vaš Reference-Only guidance. |
| `reference_strength` |  | number | no | `0.65` | -3 – 3 | Reference-kipeski zor ande reference_only keripe; bi dino reference kipesko, kadava strength setting naj efekto. |
| `reference_start` |  | number | no | `0` | 0 – 1 | Reference guidance start point, ekspresime sar procento savorre timesteps-enge. |
| `reference_end` |  | number | no | `1` | 0 – 1 | Reference guidance end point, ekspresime sar procento savorre timesteps-enge. |
| `base_shift` |  | number | no | `0.5` | 0.01 – 5 | Baseline shift aplikime pa scheduled timesteps. |
| `max_shift` |  | number | no | `1.15` | 0.01 – 5 | Maksimalno shift aplikime pa scheduled timesteps. |
| `output_format` |  | enum (string) | no | `png` | `jpeg`, `png` | Fajlo-formato e rezultato kipoqo. |
| `use_beta_schedule` |  | boolean | no | `false` |  | Kontrolinel vaj te use-kerel beta sigma. |
| `sigma_schedule` |  | string \| null | no |  |  | Sigma schedule savo use-kerel pes andar denoising. |
| `scheduler` |  | enum (string) | no | `euler` | `euler`, `dpmpp_2m` | Scheduler savo use-kerel pes andar denoising. |
| `negative_prompt` |  | string | no | `` |  | Negačo prompto procesime e NAG-sa standardno te mukhel e specifikime na-želime feature-ja ande generime kipa. |
| `nag_scale` |  | number | no | `3` | ≤ 10, > 1 | Negače-promptesko arakhavipe kontrolime e NAG skala: kana bararel les, o generime kipo si majbut aver e negače opisestar. |
| `nag_tau` |  | number | no | `2.5` | > 0 | NAG tau setting vaš hidden-state normalization; rekomendime si te mukhel les bi promena. Kana bararel les, slabarel normalization thaj šaj kerel na-čekime odvojipe katar originalo kipo. |
| `nag_alpha` |  | number | no | `0.25` | ≤ 1, > 0 | NAG alpha phenel save pozitivno prompto dromarel e normalized guidance, save jekhinel pozitivno thaj negačo prompto. Kadava finalo weighting del majbut zor e pozitivne promptoske pe tele setting-ja thaj ciknarel redirection pe upral setting-ja. |
| `nag_end` |  | number | no | `0.25` | ≤ 1, > 0 | NAG-o phagipe sikavdo sar proporcija e keripnasqe korakengo. E FLUX-esqe originalna atencijake procesorja len upral i buti kana NAG agorisarel odi anglutni proporcija. |

File parameters (`reference_image_url`) take a public `https://` URL, a `data:` URI up to 10 MB, or the `file_url` of an upload from `POST /files`.

## Example input

Required parameters only:

```json
{
  "prompt": "A red fox trots through fresh snow at sunrise, soft golden light, shallow depth of field"
}
```

A fuller example:

```json
{
  "prompt": "A red fox trots through fresh snow at sunrise, soft golden light, shallow depth of field"
}
```

## Run it

Set `DOITONG_API_KEY` to a key from https://doitong.com/developers/dashboard#keys. `?wait=20` returns the finished request in the same call when it is ready within 20 seconds; otherwise poll `GET /requests/{id}` (it also accepts `?wait=`), or pass `webhook_url`.

### curl

```bash
# Run the model; wait up to 20 s for the finished result in the same call
curl -X POST "https://api.doitong.ru/v1/run/flux-general?wait=20" \
  -H "Authorization: Bearer $DOITONG_API_KEY" \
  -H "Content-Type: application/json" \
  -d '{
    "prompt": "A red fox trots through fresh snow at sunrise, soft golden light, shallow depth of field"
  }'

# Still "queued" or "running"? Poll with the id from the response:
curl "https://api.doitong.ru/v1/requests/REQUEST_ID?wait=20" \
  -H "Authorization: Bearer $DOITONG_API_KEY"
```

### JavaScript

```javascript
const API = "https://api.doitong.ru/v1";
const headers = {
  "Authorization": "Bearer " + process.env.DOITONG_API_KEY,
  "Content-Type": "application/json",
};

// Run the model; wait up to 20 s for the finished result in the same call
let res = await fetch(API + "/run/flux-general?wait=20", {
  method: "POST",
  headers,
  body: JSON.stringify({
    "prompt": "A red fox trots through fresh snow at sunrise, soft golden light, shallow depth of field"
  }),
});
let request = await res.json();
if (!res.ok) throw new Error(request.error.code + ": " + request.error.message);

// Not finished yet: long-poll until it is
while (request.status === "queued" || request.status === "running") {
  res = await fetch(API + "/requests/" + request.id + "?wait=20", { headers });
  request = await res.json();
}
if (request.status !== "succeeded") throw new Error(JSON.stringify(request.error));
console.log(request.outputs.map((o) => o.url), request.cost.credits + " API credits ($" + request.cost.usd + ")");
```

### Python

```python
import os
import requests

API = "https://api.doitong.ru/v1"
headers = {"Authorization": "Bearer " + os.environ["DOITONG_API_KEY"]}

payload = {
    "prompt": "A red fox trots through fresh snow at sunrise, soft golden light, shallow depth of field",
}

# Run the model; wait up to 20 s for the finished result in the same call
r = requests.post(API + "/run/flux-general", params={"wait": 20}, json=payload, headers=headers)
request = r.json()
if not r.ok:
    raise RuntimeError(request["error"]["code"] + ": " + request["error"]["message"])

# Not finished yet: long-poll until it is
while request["status"] in ("queued", "running"):
    request = requests.get(API + "/requests/" + request["id"], params={"wait": 20}, headers=headers).json()
if request["status"] != "succeeded":
    raise RuntimeError(request["error"])
print([o["url"] for o in request["outputs"]], request["cost"]["credits"], "API credits", "$" + request["cost"]["usd"])
```

### MCP

The MCP server at `https://api.doitong.ru/v1/mcp` exposes the tools `search_models`, `get_model`, `quote`, `run`, `get_request`, `cancel_request`, `list_requests`, `create_upload` and `get_account`. A `run` call for this model:

```json
{
  "jsonrpc": "2.0",
  "id": 1,
  "method": "tools/call",
  "params": {
    "name": "run",
    "arguments": {
      "model_id": "flux-general",
      "input": {
        "prompt": "A red fox trots through fresh snow at sunrise, soft golden light, shallow depth of field"
      },
      "wait_seconds": 20
    }
  }
}
```

## Response

Every call returns a request object. `status` is one of `queued`, `running`, `succeeded`, `failed`, `canceled`. `outputs` lists the generated files with URLs on our storage (kept forever, or 7 days with `?storage=temporary`; `storage` says which); `output` is the model's own result object with the same URLs.

```json
{
  "id": "req_8k2m4q7x1z9c3v5b6n0p2r4t",
  "object": "request",
  "model": "flux-general",
  "status": "succeeded",
  "created_at": "2026-10-20T12:00:00Z",
  "started_at": "2026-10-20T12:00:02Z",
  "completed_at": "2026-10-20T12:00:09Z",
  "queue_position": null,
  "cost": {
    "credits": 300,
    "usd": "0.30",
    "charged": 300,
    "refunded": 0
  },
  "input": {
    "prompt": "A red fox trots through fresh snow at sunrise, soft golden light, shallow depth of field"
  },
  "output": {
    "images": [
      {
        "url": "https://content.doitong.com/dev-api/2026/10/20/req_8k2m4q7x1z9c3v5b6n0p2r4t/0-output.jpeg",
        "width": 1024,
        "height": 768,
        "content_type": "image/jpeg"
      }
    ],
    "timings": {},
    "seed": 42,
    "has_nsfw_concepts": [
      false
    ],
    "prompt": "string"
  },
  "outputs": [
    {
      "type": "image",
      "url": "https://content.doitong.com/dev-api/2026/10/20/req_8k2m4q7x1z9c3v5b6n0p2r4t/0-output.jpeg",
      "content_type": "image/jpeg",
      "file_size": 1843200,
      "width": 1024,
      "height": 768,
      "stored": true
    }
  ],
  "error": null,
  "metrics": {
    "inference_seconds": 6.8
  },
  "urls": {
    "self": "https://api.doitong.ru/v1/requests/req_8k2m4q7x1z9c3v5b6n0p2r4t",
    "cancel": "https://api.doitong.ru/v1/requests/req_8k2m4q7x1z9c3v5b6n0p2r4t/cancel"
  }
}
```

### Output fields (`output`)

| Field | Type | Description |
|---|---|---|
| `images` | array of object {url, width, height, content_type} | Fajloskere informacie vaš e kerde kipura. |
| `timings` | object |  |
| `seed` | integer | Kipo-generiripeqo seed, inkludirindoj o randomno kidlo valoro kana o inputo na sas seed; averčes, repetirisar o dindo valoro. |
| `has_nsfw_concepts` | array of boolean | Sikavel te si NSFW koncepto ande generirime kipo. |
| `prompt` | string | Prompto utilizuime ko kipoqo generiripe. |

## Related models

- [FLUX.1 \[dev\] with Controlnets and Loras · Differential Diffusion](https://doitong.com/developers/models/flux-general/differential-diffusion.md) (`flux-general/differential-diffusion`): $0.138 / image
- [FLUX.1 \[dev\] with Controlnets and Loras · Image to Image](https://doitong.com/developers/models/flux-general/image-to-image.md) (`flux-general/image-to-image`): $0.15 / image
- [FLUX.1 \[dev\] with Controlnets and Loras · Inpainting](https://doitong.com/developers/models/flux-general/inpainting.md) (`flux-general/inpainting`): $0.192 / image
- [FLUX.1 \[dev\] with Controlnets and Loras · Rf Inversion](https://doitong.com/developers/models/flux-general/rf-inversion.md) (`flux-general/rf-inversion`): $0.025 / image
- [FLUX.1 \[dev\]](https://doitong.com/developers/models/flux/dev.md) (`flux/dev`): $0.025 / megapixel
- [FLUX.1 \[schnell\]](https://doitong.com/developers/models/flux/schnell.md) (`flux/schnell`): $0.003 / megapixel
- [FLUX.2 \[dev\]](https://doitong.com/developers/models/flux-2.md) (`flux-2`): $0.012 / megapixel
- [FLUX.2 \[pro\]](https://doitong.com/developers/models/flux-2-pro.md) (`flux-2-pro`): $0.015 / megapixel of output image

## Links

- HTML page: https://doitong.com/developers/models/flux-general
- All models and guides for AI agents: https://doitong.com/developers/llms.txt
- OpenAPI 3.1 with this model's typed request body: https://doitong.com/developers/openapi.json?model=flux-general
- Errors: https://doitong.com/developers/docs/errors
- Model details as JSON: https://api.doitong.ru/v1/models/flux-general
